/*
		    		-------------------------------------------------------------------
		    		MOUSE 2.3
		    		nta.pourcelot@libertysurf.fr
		    		Compil avec Ti-gcc
		    		Librairies documentes par Zeljko Juric
		    		12/06/2001
		    		--------------------------------------------------------------------

	 Version 1.00 was first version, many functions were inspired from flib or TIGCCLIB v1.5.
	 Version 1.01 was first public version after (a little) optimization.
	 Version 1.02 : one minor bug fixed after Vincent Victorix report.
	 This was for one year defintive
	 Version 1.1 includes Grayscale option.
	 Version 2.0 was supposed to be definitive version, because keyboard reading was rewritten,
		grayscale was perfectly supported, and autoexit feature etc..
	 Version 2.1 includes some optimization and recognizes all keys repetition.
	 Version 2.2 recognizes arrows combinations like left+high, etc...
	 Version 2.3 includes optimizations : default arrow is now displayed using sprite8 function,
	 and plane 0 is recovered using memcpy instead of previous BitmapPut.
	 Special Thanks to :
	 -Zeljko Jurik for his wonderful library. Many ideas where taken from his documentation. :)))
	 -Franois Leiber for including flib source which allowed me to learn C-Programming
	 

	 I'm just learning C. So I don't perfectly understand all F.Leiber or Zeljko Jurik code
	 which is used here.
	 Nevertheless, I'll try to answer to any question.
	 Nota : these versions (2.0-2.3) have been finally almost totally rewritten,
	 and I think I understand now quite all that I put in this code. :)

	 	Mouse is a library for TI89-Basic programmers.
		Copyright (C) 2000-2001 Nicolas POURCELOT
		Nicolas POURCELOT
		2 imp. du petit bois
		87920 Condat/Vienne
		nta.pourcelot@libertysurf.fr 
		This program is free software; you can redistribute it and/or modify it
		under the terms of the GNU General Public License as published by the Free Software Foundation;
		either version 2 of the License, or (at your option) any later version. 
		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
		without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
		See the GNU General Public License for more details. 
		You should have received a copy of the GNU General Public License along with this program;
		if not, write to 
		the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
		
		Warning ! If you use parts of this code in your programs, they must be open-source,
		as specified in the GNU General Public License.
		Thanks. =)

*/

#define RETURN_VALUE ms

#include <nostub.h>
#include <all.h>

#define _89  //remplace by _92 to have a 92+ version

#ifdef _89       //  An idea I copied in Flib source
int _ti89;
#define _89_92(x, y) (x)  // If it's a TI89, then this fonction will return the 2nd argument
#else
int _ti92plus;
#define _89_92(x, y) (y)
#endif



 SCR_RECT ECRAN = {{0, 0, _89_92(159, 239), _89_92(99, 127)}};
 //This is kind of variable you may define as global, because there're constants used
 // in different functions.

//////////////////////////////////////////////////////////////////////////////////////////////////
//															Puts a Picture on the screen																		//
//////////////////////////////////////////////////////////////////////////////////////////////////
// Data type checking is an idea from FL
void PutPicture(unsigned char x,unsigned char y,char*str,int mode)
{
	unsigned char name[18]="",*nam;	//18=8+1+8 +1 (directory\file and first byte=0)
	
	// Acts like SymFindPtr($("str"),0); for constants, but here, str isn't a constant !
	nam = (unsigned char*)HeapDeref(((SYM_ENTRY*)SymFindPtr(strcpy(name+1, str)+strlen(str), 0))->handle);
	//entry->handle means (*entry).handle,
	//so this dereferences the handle associated with the VAT entry address called "entry"
	//You must at least dereference an handle before you may work on it.
	if (*(nam+(unsigned int)(256*(*nam)+*(nam+1)+1)) == 223)
	// Checks variable type (byte number "size of data - 3" = 223 for Pictures)
	BitmapPut(x,y, nam+2, &ECRAN, mode);
}
//////////////////////////////////////////////////////////////////////////////////////////////////


void _main()
{
		 // declaration section.
 unsigned int i, key, pas, delai, delai_init;
 void *kbq = kbd_queue ();
 int n[8] = {_89_92(80,120), _89_92(50,64), 5, 0, 0, 0, 0, A_REPLACE };
/*
{x coordinate, y coordinate, speed slow, speed medium, speed fast, no activity event (autoexit feature)
, grayscale option, Bitmap mode}
*/

 /*static MULTI_LINE arrow_shape = 
 {16,
 1,0,0,0,10,
 1,0,0,7,7,
 1,7,8,5,8,
 1,5,10,7,13,
 1,2,9,5,14,
 1,5,9,5,9,
 1,6,14,6,14,
 1,1,10,1,10,
 0,1,2,1,9,
 0,2,3,2,8,
 0,3,4,3,9,
 0,4,5,4,11,
 0,5,6,5,7,
 0,5,11,5,13,
 0,6,7,6,7,
 0,6,13,6,13
 };*/							//2.0-2.2 Mouse versions
 static unsigned char sprite[] = {0x80,0xC0,0xA0,0x90,0x88,0x84,0x82,0x81,
 0x87,0xA4,0xD4,0x12,0x0A,0x09,0x06};
 static unsigned char imask[] = {~0x00,~0x00,~0x40,~0x60,~0x70,~0x78,~0x7C,~0x7E,
 ~0x78,~0x58,~0x08,~0x0C,~0x04,~0x06,~0x00};

/* Draws default arrow.
 16 is lines' number, 1 is first line mode, 0,0,0,10 are x0,y0,x1,y1 for first line ,
 1 is second line mode, etc...*/

 //unsigned char *nam;
 unsigned char ige[18],rq[40],light_picture[18], RepetitionFlag;
 //SYM_ENTRY *entry;
 ESI arg;
 LCD_BUFFER LCDRecoverBuffer,LCDPlane0Buffer;  // Declares a buffer


 SetCurClip (&ECRAN);

 delai_init = OSInitKeyInitDelay (80);  // Sets the initial autorepeat key delay.
 delai = OSInitBetweenKeyDelay(8);    //Sets the rate at which a key autorepeats. 
 strcpy(rq,"");   // Affects "" to rq (by default, no message will appear)
 strcpy(ige,"");   // Affects "" to ige (by default, an arrow will be displayed)
  
// Reads external arguments given to the program.
  InitArgPtr(arg);				//  Initializes pointer arg so as it points to the first program argument.
  if (GetArgType(arg) == STR_TAG) strncpy(ige, GetStrnArg(arg),17);  // Check if the argument is a string
  for (i=0; i<=7 ;i++)
  {
  if (GetArgType(arg) == POSINT_TAG) n[i] = GetIntArg(arg);  // Idem, but with a positive integer
   }
  if (GetArgType(arg) == STR_TAG) strncpy(rq, GetStrnArg(arg),35);
/*
Thanks to Vincent Victorix who reported me this stupid bug :
I wrote 'strcpy(rq, GetStrn(arg));' without checking size of rq !
This is done using strncpy. :)
*/
  if (GetArgType(arg) == STR_TAG) strcpy(light_picture, GetStrnArg(arg)); 
  // Check if the argument is a string

 if (strcmp(rq,""))  ST_showHelp(rq);   // Displays optionnal message if rq is not equal to ""
 LCD_save(LCDRecoverBuffer);  // Saves the screen inside buffer
	if (n[6])  
	{
			OSSetSR (0x0000); // So as to enable GrayOn function.
		 //Breakoff from Flib for example made mouse crash
		 //because it let intentionnally interrupts disabled.
		 if (!GrayOn()) n[6] = 0;
	}
	if (n[6])
	{
		SetPlane(0);
		PutPicture(0,0,light_picture,A_REPLACE);	// Puts a bitmap on the screen
		memcpy(LCDPlane0Buffer,GetPlane(LIGHT_PLANE),LCD_SIZE);
		// correspond to LCD_save(LCDPlane0Buffer);
		//please read next comments :)
	}
   do
  {
   for (i=0;i<=n[6];i++)
   {
		   if (n[6] == 1) SetPlane (i);
		   if ((i)||(!n[6]))
		   {
		   		memcpy(GetPlane(DARK_PLANE),LCDRecoverBuffer,LCD_SIZE);  // restores plane 1
			   //Acts like LCD_restore, but with grayscale activated, you can't use LCD_restore anymore,
			   //because plane1 address isn't default screen address !
			   //(LCD_restore(buffer) is definited as memcpy(LCD_SCREEN,buffer,LCD_SIZE))
			   // (LCD_SCREEN is default screen address, which value is 0x4C00)
			   //(More precisely, on HW2 you must not assume that any plane is stored on 0x4C00 address,
			   //as, here for example, plane 1 seemed to be on HW1.)
		   }
		   else
		   {
			   memcpy(GetPlane(LIGHT_PLANE),LCDPlane0Buffer,LCD_SIZE); 
			   // restores plane 0 ( memcpy is faster way than PutPicture :) )
			   //Acts like LCD_restore, but with grayscale activated,
			   //plane0 address isn't default screen address !...
		   }
		   
	    if (strcmp(ige, ""))
		  {
			   	// Puts a bitmap on the screen
			   PutPicture(n[0], n[1],ige,n[7]);  
		   }
		  else   // Draws default Bitmap
		  {
			  //DrawMultiLines(n[0], n[1], &arrow_shape); //2.0-2.2 Mouse versions
			  Sprite8(n[0], n[1],15, imask, GetPlane(i),SPRT_AND);
			  Sprite8(n[0], n[1],15, sprite, GetPlane(i),SPRT_OR);
			  //Sprite is faster way than DrawMultiLines (previous versions) or BitmapPut.
			 }
   }
  

  OSFreeTimer (USER_TIMER);
  OSRegisterTimer (USER_TIMER, 20*n[5]);
  key = 0;
  RepetitionFlag = 0;

  while (((!OSTimerExpired (USER_TIMER))||(n[5] == 0))&&(OSdequeue (&key, kbq)))
	{
  if (n[6] == 0) idle();
	if (OSTimerExpired (APD_TIMER))
	{
	off();
	OSInitKeyInitDelay (80);  // Sets the initial autorepeat key delay.
	OSInitBetweenKeyDelay(8) ;    //Sets the rate at which a key autorepeats. 
 	OSTimerRestart(APD_TIMER);		// Reset APD Timer to its initial value
	}
	}
	OSTimerRestart(APD_TIMER);
/*	
	Nota Bene : Extracts from Zejko Jurik doc :
*******************************************************
	  	Key	None	Shift	2nd	Diamond	Alpha	
		Up	337	8529	4433	16721	33105	
		Right	344	8536	4440	16728	33112	
		Down	340	8532	4436	16724	33108	
		Left	338	8530	4434	16722	33106	

*******************************************************
if (!Osdequeue (&key, kbq)
{
//Do something with key
}
*******************************************************
//To wait 5s :
OSFreeTimer (USER_TIMER);
OSRegisterTimer (USER_TIMER, 5*20);
while (!OSTimerExpired (USER_TIMER));
*******************************************************
//To modify a Timer
OSFreeTimer (APD_TIMER);
OSRegisterTimer (APD_TIMER, 100*20);
*******************************************************
// Timers'list
enum Timer {BATT_TIMER = 1, APD_Timer = 2, LIO_Timer = 3, CURSOR_TIMER = 4,
MISC_TIMER = 5, USER_TIMER = 5, USER_TIMER = 6};
*******************************************************
*/	


	 if (((key <= 6492)&&(key>=6481))||((key <= 18778)&&(key>=18769))||((key <= 2396)&&(key>=2385)))
	 {
	 RepetitionFlag = 1;	// The key was already pressed just before.
	 key -= 2048;
	 } 
   // TIOS add 2048 (0x800) to pressed key code in case of repetition.
   pas = n[2];  // affects value 'default speed' to 'pas'

   if ((key <= 4444)&&(key>=4433))  // idem for middle speed
   {
   pas = n[3];
   if (pas != 0)  key -= 4096;
   }
   if ((key <= 16732)&&(key>=16721))  // high speed
   {
   pas = n[4];
   if (pas != 0)  key -= 16384;
   }

   if ((key == _89_92(337, 338))||(key == 339)||(key == _89_92(345,342)))  n[1] -= pas;
   //  changes the cursor position
   // 'pas' is the speed
   if (key == _89_92(344, 340)||(key == 348)||(key == _89_92(345,342)))  n[0] += pas;
   if (key == _89_92(340, 344)||(key == 348)||(key == _89_92(342,345)))  n[1] += pas;
   if (key == _89_92(338, 337)||(key == 339)||(key == _89_92(342,345)))  n[0] -= pas;
   

	if (RepetitionFlag == 1)				// if key was already pressed just before.
   {
   if (n[0] <= 0 ) n[0] = 0;        //   so, the cursor can't go away    
   if (n[1] <= 0 ) n[1] = 0;
   if (n[0] > _89_92(159, 239)) n[0] = _89_92(159, 239);
   if (n[1] > _89_92(99, 127))  n[1] = _89_92(99, 127);
	 }
	else														// else, ...
	{
   if (n[0] < 0 ) n[0] = _89_92(159, 239);        //   so, the cursor can't go away    
   if (n[1] < 0 ) n[1] = _89_92(99, 127);
   if (n[0] > _89_92(159, 239)) n[0] = 0;
   if (n[1] > _89_92(99, 127))  n[1] = 0;		
	}
	
	
   if ((key == 4363)||(key == 16651))
   { 	off();   // Turns the calculator off
   		OSInitKeyInitDelay (80);  // Sets the initial autorepeat key delay.
   		OSInitBetweenKeyDelay(8) ;    //Sets the rate at which a key autorepeats. 
   		/*
   		This is due to TIOS behaviour :
   		after the calc is turned on, these delays are automatically set to their default values.
   		*/
   }
   
   }
   while ((((key >= 337)&&(key <= 348))||(key == 4363)||(key == 16651))&&(pas != 0)); 
   // && means 'and', || means 'or'
   

  push_END_TAG ();
	push_longint (key);
	push_longint (n[1]);
	push_longint (n[0]);
  push_LIST_TAG ();

   LCD_restore(LCDRecoverBuffer);   // Restores initial screen
   OSInitKeyInitDelay (delai_init);       // Restores initial parameters
   OSInitBetweenKeyDelay(delai);

   OSClearBreak();      // Clears "[ON] key pressed" flag
	 GrayOff();
}
